library fs_shim.test.utils_part_tests;

import 'package:fs_shim/fs.dart';
import 'package:path/path.dart';

import 'test_common.dart';

void main() {
  defineTests(memoryFileSystemTestContext);
}

FileSystemTestContext _ctx;

FileSystem get fs => _ctx.fs;

void defineTests(FileSystemTestContext ctx) {
  _ctx = ctx;
  group('part', () {
    test('splitParts', () async {
      final top = await ctx.prepare();

      var parts = ctx.fs.path.split(top.path);
      expect(parts, contains('splitParts'));

      // always working
      parts = splitParts(top.path);
      expect(parts, contains('splitParts'));

      // also always working (the implementation)
      parts = windows.split(top.path);
      expect(parts, contains('splitParts'));

      if (!contextIsWindows) {
        parts = url.split(top.path);
        expect(parts, contains('splitParts'));

        parts = posix.split(top.path);
        expect(parts, contains('splitParts'));
      }
    });
  });
}
